# InSillyClo

## Description

InSillyClo supports cloning work-flow based on golden-gate assembly technologies. It will compute for you the DNA sequence of the plasmids to be constructed, give the dilutions of the input plasmids and simulate verification steps done by PCR or restriction.

This work is still in progress, please report any issue to henri.galez@pasteur.fr.

## Installation

InSillyClo is divide in 2 pieces of software:
	1. Assembly Designer to define the type of assembly (number of input plasmids, if they are mandatory and if their name should be interpreted)
	2. Assembly Simulator to simulate the assembly and compute useful information for the cloning work-flow

To use these package:

1. Set up the python environment.
    
- Download the InSillyClo repository on your PC in a given location (_C:\Users\Henri\Documents\henri_galez\InSiliClo_ in my case)

- Install [Anaconda](https://www.anaconda.com/download) or [miniconda](https://docs.conda.io/projects/miniconda/en/latest/)

- Open anaconda prompt (type _Anaconda prompt_ in the start menu on Windows)

- Run the command `conda config --add channels bioconda`

- Run the command `conda config --add channels conda-forge`

- Run the command `conda config --add channels r`

- Change location to where you stored InSillyClo files by typing in the prompt `cd C:\...` (with the previous it would be of path `cd C:\Users\Henri\Documents\henri_galez\InSiliClo`, this should be run each time you open the prompt to use InSillyClo)

- Run the command `conda env create -f InSillyClo.yml` to create the environment with all the required packages for the software (if it does not work, see the section installation issues)

- Activate the environment with `conda activate InSillyClo` (this should be run each time you open the prompt to use InSillyClo) 

2. Launch Assembly Designer by running in the prompt `python Assembly_Designer.py`, define and save your assembly (.pkl file).

3. Use the template (DB_oP_template.csv) generated by Assembly Designer to define the plasmids you want to build.

4. Launch Assembly Simulator by running in the prompt `python Assembly_Simulator.py`.

Once you have defined your assembly and obtained the .pkl file, you just need to repeat steps 3 and 4 each time you are making a new cloning work-flow. Be careful to activate the InSillyClo environement in the prompt.


The software needs input files and folder which have some requirements:
- Database of primer should be a .csv file with two columns _Name_ and _Oligo sequence_
- Database of input plasmids should be a .csv file with at least two columns _pID_ and _Name_, and a third one named _Interpretation_ if you are using this feature of the software (an example is given with plasmids from the Yeast Tool Kit from Dueber Lab https://www.addgene.org/kits/moclo-ytk/)
- A folder with the sequences of input plasmids in GenBank formats, with the filenames matching the _pID_ in the DataBase of input plasmids.

### Installation issues

If creating a environment from the YAML file (.yml) did not work, enter the following commands in the anaconda terminal:

- `conda create --name InSillyClo`

- `conda activate InSillyClo`

- `conda install numpy=1.26.3`

- `conda install pandas=2.1.4`

- `conda install pillow=10.2.0`

- `conda install matplotlib=3.8.2`

- `conda install biopython=1.83`

You can then go back to the Usage section at the bullet 2. .


## Usage

### Assembly Designer

Here is a Description of the entries of the app:
- _Name_ : name of the assembly
- _Backbone_ : if you want to consider one of your input plasmids as backbone (input plasmid containing the antibiotic marker that will be in the output plasmid)
- _Backbone in output_: if your want the name of the backbone to be in the name of the ouptut plasmid
- _Backbone position_ : if you chose to add the backbone in the name of output plasmid, then you say if you want it at the beginning or at the end
- _Output separator_ : when computing the name of the outpus plasmid, input part names will be separated by what you enter Here
- _Interpretable_ : if you want your output plasmid to have an interpretation
- _Part Side_: work in progress

To add a input part, click on _Add Input Part_ to open a new window:
- _Name_ : name of the input part
- _Mandatory_ : check to make the part mandatory (if mandatory, Assembly Simulator will raise an error if this part is missing in your assembly)
- _Separable_ : if the part can be separated in subparts
- _Separator_ : character that will determine subparts composing a part
- _Interpretable_ : if you are using interpretation to define standardized parts
- _Number of interpretations_ : enter the maximum number of subparts (because it corresponds to the maxium number of interpretations)
- Click on _Add interpretation_ to open the window and specify them. The logic is that on the line 1 _Interpretation 1_ their is no separator, on line 2 (in case you chose 2 interpretations or higher) with _Interpretation 2_ you have 2 entries. This is for when a part is composed of two subparts divied by the _separator_ you specified. In the first entry enter the interpretation of the first subpart and in the second the interpretation of the second subpart. If you have a line 3 it means that you can have 3 subparts composing one part and so on...  

Assembly Designer will generate:
- .pkl file : which store the features of your assembly
- .txt file : wich gives you in human readable language the features of your assembly
- DB_oP_template.csv : a template file to be used to define the plasmid you want to build. It will be used as input for Assembly Simulator.



### Assembly Simulator

The 2 first section _Setting Directories_ and _Importing databases_ is where say where to find input files. To make your life easy, you can organize your file architecture in \Project\Round\ so that after entering the project and the round you only have to click on _Update cloning folder_ to automatically fill in _Cloning folder_ and _Output plasmid DB_. Default paths are set for _Plasmid repository_, _Input plasmid DB_ and _Primer DB_ but feel free to change them of course.
Input files should fulfill some requirements:
- _Output plasmid DB_ : make sure to use the template CSV file generated by Assembly Designer to have to correct columns in your file
- _Input plasmid DB_ : 2 mandatory columns: _pID_ and  _Name_. An accesory column _Interpretation_ if you are using them.
- _DB primer_ : 2 mandatory columns: _Name_ and _Oligo sequence_.
- _Plasmid repository_ : contains the Genbank files of your input plasmids, and the name of the each genbank file should be its pID.

Once you have set all the directories you can import the input files. Messages in the terminal should appear to say if it went well or not.

The following section _Parameters and preferences_ allows to define how you are doing your golden gate assembly:
- _Dilution method_ : this where you choose how you are diluting the input plasmids to reach equimolar mix. Since the software have access to the plasmid sequence it can calculate the molecular weight so that after you entered (at a later stage) the concentration in ng/µl it knows the molar concentration of your purified input plasmids. Given the quantity n (in fmol) that you want to have for each input plasmid, you can set _dilution_ which will compute the volume you need from the purified plasmids to add the correct amount. This has an inconvenient, if you have very concentrated plasmids then you will need to add very small amount which is not easy to pipette. The other dilution method, _one microL_, is better regarding this issue. In this method, you will dilute your purified input plasmids to set them at an intermediary concentration so that you only need to add the volume entered in _volume of part (µL)_. This method is names _one microL_ because to dilute to the intermediary step I add 1 µL of purified plasmid and then the software gives me the volume of water to add. In my case _volume of part (µL)_ is set to 1 µL. so I first dilute the purified plasmid by mixing 1 µL of plasmid with the volume of water given by the software and then take 1 µL of this intermediary dilution to put in the final assembly mix.
- _Volume enzbuf (µL)_ : volume of enzymes and buffer in your final mix. It is used to compute the volume of water that will be needed to reach the total volume.
- _Volume total (µL)_ : total volume of the reaction.
- _Type IIs enzyme_ : restriction enzyme which your are using to make your assembly.
-  _Assembly verification_ : to choose wether your are checking assemblies by digestion, PCR or both. Click on _Set verification_ to confirm your choice and enter in _PCR verification_ and/or _Digestion verification_ if you are using primers and/or enzymes that you specifiec in the DB_OP file (there are dedicated columns in the template given by Assembly Designer) or if you prefer to enter them manually.
You can change at any time default values by changing them in Assembly_Simulator.py.

Once everything is set, click on _RUN ASSEMBY_. Messages in the prompt are showing what the script is doing, specific message error should appear there. New lines should have appeared in the window for each input plasmids used to allow the user to enter the concentration of the purified input plasmids. Once you entered them, cick on _COMPUTE iP DILUTION_. I will give you the dilutions you need to make. If you chose _dilution_ as _Dilution method_ then you just care about _Volume part (µL)_ which is the volume you need to add to the reaction mix (_Volume of water_ will be 0 since here there is no intermediary dilution). If your chose _one microL_, it gives you the _Volume of H2O (µL)_ to add to  1 µL of purified plasmid to make the intermediary dilution, so that you only need to transfer the volume entered in _Volume of part (µL)_ into the reaction mix.
Below this you also have lines added for each output plasmid you want to make with the volume of H2O you need to add on top of input plasmids, enzymes and buffer to reach you total volume.
If you chose to enter manually restriction enzymes for verifiaction or primers you can also enter them here.
You can also set the final pID of your plasmid (if you have temporary names while doing the cloning and then final pID when registering plasmids in your lab DB).
If you whish to re-run the assembly, click on _RESET_ to erase data about dilutions and verification to keep a clean window.

You can click on _SIMULATE VERIFICATION_ to simulater digestion and/or PCR. Fragment lengths (and sequence) are stored for each output plasmids in DB_OP_final. The software also gives you an agarose gel simulation which is stored in the cloning folder specified at the beginning.

You can click _SAVE DB_ to save DB_oP_final_csv with all the information of the assembly procedure. It will also give you DB_iP_real which is a subset of DB_iP containing only the plasmids you need for the assembly with the dilution details.

Finally you can click _UPDATE DB & REPOSITORY_ to export the genbank files of your new plasmids in the repository folder, and write DB_iP_updated.csv wich is copy of the input plasmid DB in which the plasmids you just made are added.

### Troubleshooting

You encounter:
- Error saying your plasmid is not in the repository but you can see the file, check in the properties of file if the extension is _.gbk_ or _.gb_. Only _.gb_ files are taken for now so you would need to chand the extension of your file.
- Error in the inport of input parts. Check in the _.txt_ file generated by _Assembly Designer_ that the interpretations are correct.


## Support

You can contact henri.galez@pasteur.fr for any inquiry.

## Author

Henri Galez (with the help of ChatGPT3.5).

